<!DOCTYPE HTML>
<html lang="en">
<head>
<!-- Generated by javadoc (21) -->
<title>Source code</title>
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="description" content="source: package: org.apache.commons.cli, class: PatternOptionBuilder">
<meta name="generator" content="javadoc/SourceToHTMLConverter">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body class="source-page">
<main role="main">
<div class="source-container">
<pre><span class="source-line-no">001</span><span id="line-1">/*</span>
<span class="source-line-no">002</span><span id="line-2">  Licensed to the Apache Software Foundation (ASF) under one or more</span>
<span class="source-line-no">003</span><span id="line-3">  contributor license agreements.  See the NOTICE file distributed with</span>
<span class="source-line-no">004</span><span id="line-4">  this work for additional information regarding copyright ownership.</span>
<span class="source-line-no">005</span><span id="line-5">  The ASF licenses this file to You under the Apache License, Version 2.0</span>
<span class="source-line-no">006</span><span id="line-6">  (the "License"); you may not use this file except in compliance with</span>
<span class="source-line-no">007</span><span id="line-7">  the License.  You may obtain a copy of the License at</span>
<span class="source-line-no">008</span><span id="line-8"></span>
<span class="source-line-no">009</span><span id="line-9">      http://www.apache.org/licenses/LICENSE-2.0</span>
<span class="source-line-no">010</span><span id="line-10"></span>
<span class="source-line-no">011</span><span id="line-11">  Unless required by applicable law or agreed to in writing, software</span>
<span class="source-line-no">012</span><span id="line-12">  distributed under the License is distributed on an "AS IS" BASIS,</span>
<span class="source-line-no">013</span><span id="line-13">  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</span>
<span class="source-line-no">014</span><span id="line-14">  See the License for the specific language governing permissions and</span>
<span class="source-line-no">015</span><span id="line-15">  limitations under the License.</span>
<span class="source-line-no">016</span><span id="line-16"> */</span>
<span class="source-line-no">017</span><span id="line-17"></span>
<span class="source-line-no">018</span><span id="line-18">package org.apache.commons.cli;</span>
<span class="source-line-no">019</span><span id="line-19"></span>
<span class="source-line-no">020</span><span id="line-20">import java.io.File;</span>
<span class="source-line-no">021</span><span id="line-21">import java.io.FileInputStream;</span>
<span class="source-line-no">022</span><span id="line-22">import java.net.URL;</span>
<span class="source-line-no">023</span><span id="line-23">import java.util.Date;</span>
<span class="source-line-no">024</span><span id="line-24"></span>
<span class="source-line-no">025</span><span id="line-25">/**</span>
<span class="source-line-no">026</span><span id="line-26"> * Allows Options to be created from a single String. The pattern contains various single character flags and via an</span>
<span class="source-line-no">027</span><span id="line-27"> * optional punctuation character, their expected type.</span>
<span class="source-line-no">028</span><span id="line-28"> *</span>
<span class="source-line-no">029</span><span id="line-29"> * &lt;table border="1"&gt;</span>
<span class="source-line-no">030</span><span id="line-30"> * &lt;caption&gt;Overview of PatternOptionBuilder patterns&lt;/caption&gt;</span>
<span class="source-line-no">031</span><span id="line-31"> * &lt;tr&gt;</span>
<span class="source-line-no">032</span><span id="line-32"> * &lt;td&gt;a&lt;/td&gt;</span>
<span class="source-line-no">033</span><span id="line-33"> * &lt;td&gt;-a flag&lt;/td&gt;</span>
<span class="source-line-no">034</span><span id="line-34"> * &lt;/tr&gt;</span>
<span class="source-line-no">035</span><span id="line-35"> * &lt;tr&gt;</span>
<span class="source-line-no">036</span><span id="line-36"> * &lt;td&gt;b@&lt;/td&gt;</span>
<span class="source-line-no">037</span><span id="line-37"> * &lt;td&gt;-b [class name]&lt;/td&gt;</span>
<span class="source-line-no">038</span><span id="line-38"> * &lt;/tr&gt;</span>
<span class="source-line-no">039</span><span id="line-39"> * &lt;tr&gt;</span>
<span class="source-line-no">040</span><span id="line-40"> * &lt;td&gt;c&amp;gt;&lt;/td&gt;</span>
<span class="source-line-no">041</span><span id="line-41"> * &lt;td&gt;-c [file name]&lt;/td&gt;</span>
<span class="source-line-no">042</span><span id="line-42"> * &lt;/tr&gt;</span>
<span class="source-line-no">043</span><span id="line-43"> * &lt;tr&gt;</span>
<span class="source-line-no">044</span><span id="line-44"> * &lt;td&gt;d+&lt;/td&gt;</span>
<span class="source-line-no">045</span><span id="line-45"> * &lt;td&gt;-d [class name] (creates object via empty constructor)&lt;/td&gt;</span>
<span class="source-line-no">046</span><span id="line-46"> * &lt;/tr&gt;</span>
<span class="source-line-no">047</span><span id="line-47"> * &lt;tr&gt;</span>
<span class="source-line-no">048</span><span id="line-48"> * &lt;td&gt;e%&lt;/td&gt;</span>
<span class="source-line-no">049</span><span id="line-49"> * &lt;td&gt;-e [number] (creates Double/Long instance depending on existing of a '.')&lt;/td&gt;</span>
<span class="source-line-no">050</span><span id="line-50"> * &lt;/tr&gt;</span>
<span class="source-line-no">051</span><span id="line-51"> * &lt;tr&gt;</span>
<span class="source-line-no">052</span><span id="line-52"> * &lt;td&gt;f/&lt;/td&gt;</span>
<span class="source-line-no">053</span><span id="line-53"> * &lt;td&gt;-f [URL]&lt;/td&gt;</span>
<span class="source-line-no">054</span><span id="line-54"> * &lt;/tr&gt;</span>
<span class="source-line-no">055</span><span id="line-55"> * &lt;tr&gt;</span>
<span class="source-line-no">056</span><span id="line-56"> * &lt;td&gt;g:&lt;/td&gt;</span>
<span class="source-line-no">057</span><span id="line-57"> * &lt;td&gt;-g [string]&lt;/td&gt;</span>
<span class="source-line-no">058</span><span id="line-58"> * &lt;/tr&gt;</span>
<span class="source-line-no">059</span><span id="line-59"> * &lt;/table&gt;</span>
<span class="source-line-no">060</span><span id="line-60"> *</span>
<span class="source-line-no">061</span><span id="line-61"> * &lt;p&gt;</span>
<span class="source-line-no">062</span><span id="line-62"> * For example, the following allows command line flags of '-v -p string-value -f /dir/file'. The exclamation mark</span>
<span class="source-line-no">063</span><span id="line-63"> * precede a mandatory option.</span>
<span class="source-line-no">064</span><span id="line-64"> * &lt;/p&gt;</span>
<span class="source-line-no">065</span><span id="line-65"> *</span>
<span class="source-line-no">066</span><span id="line-66"> * &lt;pre&gt;</span>
<span class="source-line-no">067</span><span id="line-67"> * Options options = PatternOptionBuilder.parsePattern("vp:!f/");</span>
<span class="source-line-no">068</span><span id="line-68"> * &lt;/pre&gt;</span>
<span class="source-line-no">069</span><span id="line-69"> *</span>
<span class="source-line-no">070</span><span id="line-70"> * &lt;p&gt;</span>
<span class="source-line-no">071</span><span id="line-71"> * TODO These need to break out to OptionType and also to be pluggable.</span>
<span class="source-line-no">072</span><span id="line-72"> * &lt;/p&gt;</span>
<span class="source-line-no">073</span><span id="line-73"> */</span>
<span class="source-line-no">074</span><span id="line-74">public class PatternOptionBuilder {</span>
<span class="source-line-no">075</span><span id="line-75">    /** String class */</span>
<span class="source-line-no">076</span><span id="line-76">    public static final Class&lt;String&gt; STRING_VALUE = String.class;</span>
<span class="source-line-no">077</span><span id="line-77"></span>
<span class="source-line-no">078</span><span id="line-78">    /** Object class */</span>
<span class="source-line-no">079</span><span id="line-79">    public static final Class&lt;Object&gt; OBJECT_VALUE = Object.class;</span>
<span class="source-line-no">080</span><span id="line-80"></span>
<span class="source-line-no">081</span><span id="line-81">    /** Number class */</span>
<span class="source-line-no">082</span><span id="line-82">    public static final Class&lt;Number&gt; NUMBER_VALUE = Number.class;</span>
<span class="source-line-no">083</span><span id="line-83"></span>
<span class="source-line-no">084</span><span id="line-84">    /** Date class */</span>
<span class="source-line-no">085</span><span id="line-85">    public static final Class&lt;Date&gt; DATE_VALUE = Date.class;</span>
<span class="source-line-no">086</span><span id="line-86"></span>
<span class="source-line-no">087</span><span id="line-87">    /** Class class */</span>
<span class="source-line-no">088</span><span id="line-88">    public static final Class&lt;?&gt; CLASS_VALUE = Class.class;</span>
<span class="source-line-no">089</span><span id="line-89"></span>
<span class="source-line-no">090</span><span id="line-90">    /// can we do this one??</span>
<span class="source-line-no">091</span><span id="line-91">    // is meant to check that the file exists, else it errors.</span>
<span class="source-line-no">092</span><span id="line-92">    // ie) it's for reading not writing.</span>
<span class="source-line-no">093</span><span id="line-93"></span>
<span class="source-line-no">094</span><span id="line-94">    /** FileInputStream class */</span>
<span class="source-line-no">095</span><span id="line-95">    public static final Class&lt;FileInputStream&gt; EXISTING_FILE_VALUE = FileInputStream.class;</span>
<span class="source-line-no">096</span><span id="line-96"></span>
<span class="source-line-no">097</span><span id="line-97">    /** File class */</span>
<span class="source-line-no">098</span><span id="line-98">    public static final Class&lt;File&gt; FILE_VALUE = File.class;</span>
<span class="source-line-no">099</span><span id="line-99"></span>
<span class="source-line-no">100</span><span id="line-100">    /** File array class */</span>
<span class="source-line-no">101</span><span id="line-101">    public static final Class&lt;File[]&gt; FILES_VALUE = File[].class;</span>
<span class="source-line-no">102</span><span id="line-102"></span>
<span class="source-line-no">103</span><span id="line-103">    /** URL class */</span>
<span class="source-line-no">104</span><span id="line-104">    public static final Class&lt;URL&gt; URL_VALUE = URL.class;</span>
<span class="source-line-no">105</span><span id="line-105"></span>
<span class="source-line-no">106</span><span id="line-106">    /**</span>
<span class="source-line-no">107</span><span id="line-107">     * Retrieve the class that {@code ch} represents.</span>
<span class="source-line-no">108</span><span id="line-108">     *</span>
<span class="source-line-no">109</span><span id="line-109">     * @param ch the specified character</span>
<span class="source-line-no">110</span><span id="line-110">     * @return The class that {@code ch} represents</span>
<span class="source-line-no">111</span><span id="line-111">     */</span>
<span class="source-line-no">112</span><span id="line-112">    public static Object getValueClass(final char ch) {</span>
<span class="source-line-no">113</span><span id="line-113">        switch (ch) {</span>
<span class="source-line-no">114</span><span id="line-114">        case '@':</span>
<span class="source-line-no">115</span><span id="line-115">            return PatternOptionBuilder.OBJECT_VALUE;</span>
<span class="source-line-no">116</span><span id="line-116">        case ':':</span>
<span class="source-line-no">117</span><span id="line-117">            return PatternOptionBuilder.STRING_VALUE;</span>
<span class="source-line-no">118</span><span id="line-118">        case '%':</span>
<span class="source-line-no">119</span><span id="line-119">            return PatternOptionBuilder.NUMBER_VALUE;</span>
<span class="source-line-no">120</span><span id="line-120">        case '+':</span>
<span class="source-line-no">121</span><span id="line-121">            return PatternOptionBuilder.CLASS_VALUE;</span>
<span class="source-line-no">122</span><span id="line-122">        case '#':</span>
<span class="source-line-no">123</span><span id="line-123">            return PatternOptionBuilder.DATE_VALUE;</span>
<span class="source-line-no">124</span><span id="line-124">        case '&lt;':</span>
<span class="source-line-no">125</span><span id="line-125">            return PatternOptionBuilder.EXISTING_FILE_VALUE;</span>
<span class="source-line-no">126</span><span id="line-126">        case '&gt;':</span>
<span class="source-line-no">127</span><span id="line-127">            return PatternOptionBuilder.FILE_VALUE;</span>
<span class="source-line-no">128</span><span id="line-128">        case '*':</span>
<span class="source-line-no">129</span><span id="line-129">            return PatternOptionBuilder.FILES_VALUE;</span>
<span class="source-line-no">130</span><span id="line-130">        case '/':</span>
<span class="source-line-no">131</span><span id="line-131">            return PatternOptionBuilder.URL_VALUE;</span>
<span class="source-line-no">132</span><span id="line-132">        }</span>
<span class="source-line-no">133</span><span id="line-133"></span>
<span class="source-line-no">134</span><span id="line-134">        return null;</span>
<span class="source-line-no">135</span><span id="line-135">    }</span>
<span class="source-line-no">136</span><span id="line-136"></span>
<span class="source-line-no">137</span><span id="line-137">    /**</span>
<span class="source-line-no">138</span><span id="line-138">     * Returns whether {@code ch} is a value code, i.e. whether it represents a class in a pattern.</span>
<span class="source-line-no">139</span><span id="line-139">     *</span>
<span class="source-line-no">140</span><span id="line-140">     * @param ch the specified character</span>
<span class="source-line-no">141</span><span id="line-141">     * @return true if {@code ch} is a value code, otherwise false.</span>
<span class="source-line-no">142</span><span id="line-142">     */</span>
<span class="source-line-no">143</span><span id="line-143">    public static boolean isValueCode(final char ch) {</span>
<span class="source-line-no">144</span><span id="line-144">        return ch == '@' || ch == ':' || ch == '%' || ch == '+' || ch == '#' || ch == '&lt;' || ch == '&gt;' || ch == '*' || ch == '/' || ch == '!';</span>
<span class="source-line-no">145</span><span id="line-145">    }</span>
<span class="source-line-no">146</span><span id="line-146"></span>
<span class="source-line-no">147</span><span id="line-147">    /**</span>
<span class="source-line-no">148</span><span id="line-148">     * Returns the {@link Options} instance represented by {@code pattern}.</span>
<span class="source-line-no">149</span><span id="line-149">     *</span>
<span class="source-line-no">150</span><span id="line-150">     * @param pattern the pattern string</span>
<span class="source-line-no">151</span><span id="line-151">     * @return The {@link Options} instance</span>
<span class="source-line-no">152</span><span id="line-152">     */</span>
<span class="source-line-no">153</span><span id="line-153">    public static Options parsePattern(final String pattern) {</span>
<span class="source-line-no">154</span><span id="line-154">        char opt = ' ';</span>
<span class="source-line-no">155</span><span id="line-155">        boolean required = false;</span>
<span class="source-line-no">156</span><span id="line-156">        Class&lt;?&gt; type = null;</span>
<span class="source-line-no">157</span><span id="line-157"></span>
<span class="source-line-no">158</span><span id="line-158">        final Options options = new Options();</span>
<span class="source-line-no">159</span><span id="line-159"></span>
<span class="source-line-no">160</span><span id="line-160">        for (int i = 0; i &lt; pattern.length(); i++) {</span>
<span class="source-line-no">161</span><span id="line-161">            final char ch = pattern.charAt(i);</span>
<span class="source-line-no">162</span><span id="line-162"></span>
<span class="source-line-no">163</span><span id="line-163">            // a value code comes after an option and specifies</span>
<span class="source-line-no">164</span><span id="line-164">            // details about it</span>
<span class="source-line-no">165</span><span id="line-165">            if (!isValueCode(ch)) {</span>
<span class="source-line-no">166</span><span id="line-166">                if (opt != ' ') {</span>
<span class="source-line-no">167</span><span id="line-167">                    final Option option = Option.builder(String.valueOf(opt)).hasArg(type != null).required(required).type(type).build();</span>
<span class="source-line-no">168</span><span id="line-168"></span>
<span class="source-line-no">169</span><span id="line-169">                    // we have a previous one to deal with</span>
<span class="source-line-no">170</span><span id="line-170">                    options.addOption(option);</span>
<span class="source-line-no">171</span><span id="line-171">                    required = false;</span>
<span class="source-line-no">172</span><span id="line-172">                    type = null;</span>
<span class="source-line-no">173</span><span id="line-173">                }</span>
<span class="source-line-no">174</span><span id="line-174"></span>
<span class="source-line-no">175</span><span id="line-175">                opt = ch;</span>
<span class="source-line-no">176</span><span id="line-176">            } else if (ch == '!') {</span>
<span class="source-line-no">177</span><span id="line-177">                required = true;</span>
<span class="source-line-no">178</span><span id="line-178">            } else {</span>
<span class="source-line-no">179</span><span id="line-179">                type = (Class&lt;?&gt;) getValueClass(ch);</span>
<span class="source-line-no">180</span><span id="line-180">            }</span>
<span class="source-line-no">181</span><span id="line-181">        }</span>
<span class="source-line-no">182</span><span id="line-182"></span>
<span class="source-line-no">183</span><span id="line-183">        if (opt != ' ') {</span>
<span class="source-line-no">184</span><span id="line-184">            final Option option = Option.builder(String.valueOf(opt)).hasArg(type != null).required(required).type(type).build();</span>
<span class="source-line-no">185</span><span id="line-185"></span>
<span class="source-line-no">186</span><span id="line-186">            // we have a final one to deal with</span>
<span class="source-line-no">187</span><span id="line-187">            options.addOption(option);</span>
<span class="source-line-no">188</span><span id="line-188">        }</span>
<span class="source-line-no">189</span><span id="line-189"></span>
<span class="source-line-no">190</span><span id="line-190">        return options;</span>
<span class="source-line-no">191</span><span id="line-191">    }</span>
<span class="source-line-no">192</span><span id="line-192">}</span>




























































</pre>
</div>
</main>
</body>
</html>
